# Copyright (c) 1997-2002  Nigel P. Brown. \$Id: Identity.pm,v 1.5 2002/04/20 03:22:16 nige Exp $
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the license agreement accompanying this file.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the accompanying License for
# more details.
#
# Contact:
#---------------------------------------------------------------------------
# Nigel P. Brown,                                                           
# Danzigerstr. 14,                                                          
# Heidelberg,                                             nbrown@cnb.uam.es 
# 69124 GERMANY                      http://mathbio.nimr.mrc.ac.uk/~nbrown/ 
#---------------------------------------------------------------------------

###########################################################################
package Bio::MView::Align::Identity;

use Bio::MView::Align;
use Bio::MView::Display;
use Bio::MView::Align::Row;
use strict;

use vars qw(@ISA $Debug);

@ISA = qw(Bio::MView::Align::Sequence);

$Debug = 0;

sub new {
    my $type = shift;
    warn "${type}::new() (@_)\n"    if $Debug;
    if (@_ < 4) {
	die "${type}::new() missing arguments\n";
    }
    my ($id1, $id2, $string, $identity, $subtype) = (@_, 'identity');

    my $self = new Bio::MView::Align::Sequence($id1 . 'x' . $id2, $string);

    $self->{'identity'} = $identity;
    $self->{'parentid'} = $id1;
    $self->{'type'}     = $subtype;

    bless $self, $type;
}

sub get_identity { $_[0]->{'identity'} }
sub get_parentid { $_[0]->{'parentid'} }


###########################################################################
1;
