# Copyright (c) 1997-2002  Nigel P. Brown. \$Id: Ruler.pm,v 1.8 2002/04/21 19:47:49 nige Exp $
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the license agreement accompanying this file.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the accompanying License for
# more details.
#
# Contact:
#---------------------------------------------------------------------------
# Nigel P. Brown,                                                           
# Danzigerstr. 14,                                                          
# Heidelberg,                                             nbrown@cnb.uam.es 
# 69124 GERMANY                      http://mathbio.nimr.mrc.ac.uk/~nbrown/ 
#---------------------------------------------------------------------------

###########################################################################
package Bio::MView::Align::Ruler;

use Bio::MView::Align;
use Bio::MView::Display;
use Bio::MView::Align::Row;

use vars qw(@ISA);

@ISA = qw(Bio::MView::Align::Row);

sub new {
    my $type = shift;
    my ($length, $subtype) = (@_, 'ruler');
    my $self = {};
    bless $self, $type;

    $self->{'length'} = $length;
    $self->{'type'}   = $subtype;

    $self->reset_display;

    $self;
}

sub id     { $_[0] }
sub string { '' }
sub length { $_[0]->{'length'} }

sub reset_display { 
    $_[0]->{'display'} =
	{
	 'type'     => 'ruler',
	 'label0'   => '',
	 'label1'   => '',
	 'label2'   => '',
	 'label3'   => '',
	 'label4'   => '',
	 'label5'   => '',
	 'label6'   => '',
	 'range'    => [],
	 'number'   => 1,
	};
    $_[0];
}


###########################################################################
1;
