# -*- perl -*-
# Copyright (c) 1996-2002  Nigel P. Brown, All rights reserved. $Id: Regexps.pm,v 1.3 2002/04/20 03:23:58 nige Exp $
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the license agreement accompanying this file.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the accompanying License for
# more details.
#
# Contact:
#---------------------------------------------------------------------------
# Nigel P. Brown,                                                           
# Danzigerstr. 14,                                                          
# Heidelberg,                                             nbrown@cnb.uam.es 
# 69124 GERMANY                      http://mathbio.nimr.mrc.ac.uk/~nbrown/ 
#---------------------------------------------------------------------------

###########################################################################
# regexps for string matching numerical types
###########################################################################
package Regexps;

use Exporter;

@ISA = qw(Exporter);

@EXPORT = 
    qw(
       $RX_Uint
       $RX_Sint
       $RX_Ureal 
       $RX_Sreal
      );


#unsigned integer
$RX_Uint   = '\+?\d+';

#signed integer
$RX_Sint   = '[+-]?\d+';

#unsigned real
$RX_Ureal = '\+?(?:\d+\.\d+|\d+\.|\d+|\.\d+)?(?:[eE][+-]?\d+)?';

#signed real
$RX_Sreal = '[+-]?(?:\d+\.\d+|\d+\.|\d+|\.\d+)?(?:[eE][+-]?\d+)?';


###########################################################################
1;
